/*
 * Created on 2003/05/24
 *
 */
package com.muimi.jtype.views;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
//import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;

/**
 * @author miya
 *
 */
public class JType extends Composite{

//	private Display display;
//	private Shell shell;
//	private Composite composite;

	final static int ST_STOP = 1;
	final static int ST_PLAY = 2;
	final static int ST_WAIT = -1;
	final static int ST_RESULT = 3;
	private int status = ST_STOP;

	private long startTime;
	final static int TIME_MAX = 30;

	private ProgressBar progbar;
	private Label messageLabel;
	private Label questionLabel;
	private Label answerLabel;

	private TimerTask timer = new TimerTask();

	private QuestionStock questionStocks = QuestionStock.getInstance();
	private Question question;
	private Scorer scorer;

	/**
	 * L[͂̕
	 */
	private StringBuffer sb = new StringBuffer();


	public JType(Composite parent){
		super(parent, SWT.CENTER);

		GridLayout layout = new GridLayout();
		layout.numColumns = 1;
		setBackground(new Color(this.getDisplay(), new RGB(128, 128, 200)));
		setLayout(layout);


		progbar = new ProgressBar(this, SWT.NULL);
		progbar.setMinimum(0);
		progbar.setMaximum(TIME_MAX * 1000);
		progbar.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));


		messageLabel = new Label(this, SWT.LEFT);
		messageLabel.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		//messageLabel.setBackground(
		//	new Color(composite.getDisplay(), new RGB(255, 255, 255)));
		messageLabel.setText("");

		questionLabel = new Label(this, SWT.CENTER);
		questionLabel.setBackground(
			new Color(this.getDisplay(), new RGB(255, 255, 255)));
		questionLabel.setText("press any key to start");
		questionLabel.setLayoutData(getGD());

		answerLabel = new Label(this, SWT.NULL);
		answerLabel.setBackground(
			new Color(this.getDisplay(), new RGB(255, 255, 255)));
		answerLabel.setText("");
		answerLabel.setLayoutData(getGD());

		addKeyListener(new TypeKeyListener());
	}

	GridData getGD(){
		GridData gd = new GridData();
		gd.horizontalAlignment = GridData.FILL;
		gd.verticalAlignment = GridData.FILL;
		gd.verticalSpan = 2;
		gd.grabExcessVerticalSpace = true;
		return gd;
	}



	//
	//ANV
	//

	void actionGameStart() {
		//System.out.println("game start");

		questionLabel.setText("ready");
		status = ST_WAIT;
		timerExec(1000, new Runnable() {
			public void run() {
				status = ST_PLAY;
				scorer = new Scorer();
				startTime = System.currentTimeMillis();
				timerExec(0, timer);
				actionNextQuestion();
				sb = new StringBuffer();
				answerLabel.setText(sb.toString());
				messageLabel.setText("");
			}
		});
	}

	/**
	 * Ԑ؂
	 */
	void actionTimeUp() {
		//System.out.println("time up");
		questionLabel.setText("finished!");
		status = ST_WAIT;
		timerExec(2000, new Runnable() {
			public void run() {
				status = ST_RESULT;
				questionLabel.setText(
					scorer.getResultText() + "\n\n press start to retry");
			}
		});
	}

	/**
	 * ̖
	 */
	void actionNextQuestion() {
		//System.out.println("next question");
		question = questionStocks.next();
		questionLabel.setText(question.getWord());
	}

	/**
	 * ͌
	 */
	void actionWordEnter(String word) {
		//System.out.println("word enter : " + word);
		question.answer(word);
		scorer.addAnswer(question);
		
		boolean correct = question.isCorrect();
		messageLabel.setText(messageLabel.getText() + (correct ? "" : "~"));
		
//		System.out.println(
//			"result:"
//				+ question.isCorrect()
//				+ "/time:"
//				+ question.getAnswerTime());
		actionNextQuestion();
	}


	/**
	 * time~btasks
	 */
	void timerExec(int time, Runnable task){
		if(isDisposed()) return;
		
		getDisplay().timerExec(time, task);
	}



	/**
	 * L[͂̃Xi[
	 */
	class TypeKeyListener extends KeyAdapter {

		public void keyPressed(KeyEvent e) {

			if (status == ST_PLAY) {
				keyInGame(e);
			} else if (status == ST_STOP) {
				actionGameStart();
			} else if (status == ST_RESULT) {
				actionGameStart();
			}

		}

		private void keyInGame(KeyEvent e) {
			char c = e.character;

			//System.out.print(c);

			if (c == '\r') { //^[
				actionWordEnter(sb.toString());
				sb = new StringBuffer();
			} else {
				sb.append(c);
			}

			answerLabel.setText(sb.toString());
		}

	}

	/**
	 * ^C}[
	 */
	class TimerTask implements Runnable {

		public void run() {
			checkTime();
			if(status == ST_PLAY){
				timerExec(500, this);
			}
		}
	}

	void checkTime(){
		//System.out.println("update time");
		long now = System.currentTimeMillis();
		long time = now - startTime;

		if(!progbar.isDisposed()){
			progbar.setSelection((int) time);
		}

		if (time >= TIME_MAX * 1000) {
			actionTimeUp();
		}
	}




	/**
	 * C
	 */
	public static void main(String[] args) {
		Display display = new Display();
		Shell shell = new Shell(display);
		shell.setText("JType");
		shell.setLayout(new FillLayout());

		JType jtype = new JType(shell);

		//shell.pack();
		shell.setSize(300,200);
		shell.open();

		while (!shell.isDisposed()) {
			if (!display.isDisposed()) {
				display.readAndDispatch();
				display.sleep();
			}
		}

		display.dispose();
	}

}
